/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.34).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.owc.singularity.server.api;


import java.util.List;
import java.util.Objects;

import org.springdoc.core.annotations.ParameterObject;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.owc.singularity.server.model.Job;
import com.owc.singularity.server.model.JobConfiguration;
import com.owc.singularity.server.model.QueryOptions;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotNull;


@Validated
public interface JobsApi {

    @Operation(summary = "Get all Jobs", description = "Get the information of all jobs", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:job", "read:log", "submit:job", "stop:job" }) }, tags = { "job" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "Jobs array", content = @Content(mediaType = "application/json", array = @ArraySchema(schema = @Schema(implementation = Job.class)))) })
    @GetMapping(value = "/jobs", produces = { "application/json; charset=utf-8" })
    ResponseEntity<List<Job>> getAllJobs(@ParameterObject QueryOptions options);


    @Operation(summary = "Get a Job by id", description = "Get a single Job by id", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:job", "read:log", "submit:job", "stop:job" }) }, tags = { "job" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "Job object", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Job.class))),

            @ApiResponse(responseCode = "404", description = "Not found") })
    @GetMapping(value = "/jobs/{jobId}", produces = { "application/json; charset=utf-8" })
    ResponseEntity<Job> getJobById(
            @Parameter(in = ParameterIn.PATH, description = "ID of job to return", required = true, schema = @Schema()) @PathVariable("jobId") String jobId);


    @Operation(summary = "Get a Job log by id", description = "Get the log of a job.", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:job", "read:log", "submit:job", "stop:job" }) }, tags = { "job" })
    @ApiResponses(value = { @ApiResponse(responseCode = "200", description = "Log lines in plain text") })
    @GetMapping(value = "/jobs/{jobId}/logs", produces = { "text/plain; charset=utf-8" })
    ResponseEntity<String> getJobLogById(
            @Parameter(in = ParameterIn.PATH, description = "ID of job", required = true, schema = @Schema()) @PathVariable("jobId") String jobId,
            @Parameter(in = ParameterIn.QUERY, description = "Regex filter for log lines", schema = @Schema()) @Valid @RequestParam(value = "filter", required = false) String filter,
            @Parameter(in = ParameterIn.QUERY, description = "Number of log lines to filter", schema = @Schema()) @Valid @RequestParam(value = "lines", required = false) Integer lines,
            @Parameter(in = ParameterIn.QUERY, description = "Include source timestamps", schema = @Schema()) @Valid @RequestParam(value = "includeSourceTimestamps", required = false) Boolean includeSourceTimestamps);


    @Operation(summary = "Stop a submitted job", description = "Request the Job execution to be stopped", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:job", "read:log", "submit:job", "stop:job" }) }, tags = { "job" })
    @ApiResponses(value = { @ApiResponse(responseCode = "204", description = "Job scheduled for stop"),

            @ApiResponse(responseCode = "404", description = "Not found") })
    @DeleteMapping(value = "/jobs/{jobId}", produces = { "application/json; charset=utf-8" })
    ResponseEntity<Void> stopJobById(
            @Parameter(in = ParameterIn.PATH, description = "ID of job to stop", required = true, schema = @Schema()) @PathVariable("jobId") String jobId);


    @Operation(summary = "Submit a job for execution", description = "Submit a Job for execution", security = {
            @SecurityRequirement(name = "execution_controller_auth", scopes = { "read:job", "read:log", "submit:job", "stop:job" }) }, tags = { "job" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "201", description = "Job sumitted", content = @Content(mediaType = "application/json", schema = @Schema(implementation = Job.class))) })
    @PostMapping(value = "/jobs", produces = { "application/json; charset=utf-8" }, consumes = { "application/json" })
    ResponseEntity<Job> submitJob(@Parameter(in = ParameterIn.DEFAULT, description = "", schema = @Schema()) @Valid @RequestBody JobsApi.JobSubmission body);

    /**
     * Job submission body
     */
    @Validated
    class JobSubmission {

        @JsonProperty("configuration")
        private JobConfiguration configuration = null;

        @JsonProperty("name")
        private String name = null;

        @JsonProperty("description")
        private String description = null;

        public JobSubmission configuration(JobConfiguration _configuration) {
            this.configuration = _configuration;
            return this;
        }

        /**
         * Get configuration
         *
         * @return configuration
         **/
        @Schema(requiredMode = Schema.RequiredMode.REQUIRED, description = "")
        @NotNull
        @Valid
        public JobConfiguration getConfiguration() {
            return configuration;
        }

        public void setConfiguration(JobConfiguration configuration) {
            this.configuration = configuration;
        }

        public JobSubmission name(String name) {
            this.name = name;
            return this;
        }

        /**
         * Get name
         *
         * @return name
         **/
        @Schema(description = "")
        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public JobSubmission description(String description) {
            this.description = description;
            return this;
        }

        /**
         * Get description
         *
         * @return description
         **/
        @Schema(description = "")
        public String getDescription() {
            return description;
        }

        public void setDescription(String description) {
            this.description = description;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) {
                return true;
            }
            if (o == null || getClass() != o.getClass()) {
                return false;
            }
            JobSubmission jobSubmission = (JobSubmission) o;
            return Objects.equals(this.configuration, jobSubmission.configuration) && Objects.equals(this.name, jobSubmission.name)
                    && Objects.equals(this.description, jobSubmission.description);
        }

        @Override
        public int hashCode() {
            return Objects.hash(configuration, name, description);
        }

        @Override
        public String toString() {
            StringBuilder sb = new StringBuilder();
            sb.append("class JobsBody {\n");
            sb.append("    configuration: ").append(toIndentedString(configuration)).append("\n");
            sb.append("    name: ").append(toIndentedString(name)).append("\n");
            sb.append("    description: ").append(toIndentedString(description)).append("\n");
            sb.append("}");
            return sb.toString();
        }

        /**
         * Convert the given object to string with each line indented by 4 spaces (except the first
         * line).
         */
        private String toIndentedString(Object o) {
            if (o == null) {
                return "null";
            }
            return o.toString().replace("\n", "\n    ");
        }
    }
}
